var CardsLayer = cc.Layer.extend({
    size:null,
    cardTexture:null,
    _sprites:null,
    cardsArr:null,
    curCall:null,
    curPlayer:null,
    yourTurnLabel:null,
    logLabel:null,
    backConfirmNode:null,
    confirmDBLabel:null,
    bg:null,
    cardsThrowPosArr:null,
    ctor:function () {
        // 1. super init first
        this._super();
        //-----------------
//        this.scheduleOnce(this.init,0.3);
        this.init();
        //------------------
        return true;
    },
    init:function(){
    	cc.log("init");
            
         setTimeout(function(){
                    // leave a breadcrumb
//                    sdkbox.PluginApteligent.leaveBreadcrumb("game play page");
                    },1000);
                 
                                 
//         if(roundCount == 3)
//         {
//            sdkbox.PluginLeadBolt.init();
//         }
                                 
         // cache the ads,  if roundCount just crossed the count divisible by 3 or 5
         if((roundCount-1)%5 == 0 || (roundCount-4)%5 == 0)
         {
             cc.log("init>cacheAd---------------------------------------------- roundCount: "+roundCount);
             sdkbox.PluginAdMob.cache("round_fs");
//             sdkbox.PluginLeadBolt.loadModuleToCache("directdeal");
         }
                                 
        setTimeout(function(){sdkbox.PluginAdMob.show("top_banner");},2000);
       
        // loading settings
    	loadSettings();
                                 
        // creating buttons and ui
         var buttonNameArr = ["Back","Scores", "Sound", "Slow", "Normal", "Fast", "Very Fast"];
         //         32: device screen height <= 400
         //         50: 400 < device screen height <= 720
         //         90: device screen height > 720         
                                 
         var menu = new cc.Menu();
         
         tableBtn = new cc.MenuItemImage(res.scoreBg,res.scoreBg, this.onButtonClick, this);
         tableBtn.setName("tableBtn");
         tableBtn.setPosition(cc.p(visibleSize.width/2, visibleSize.height/2));
         tableBtn.setAnchorPoint(0.5,0.5);
         tableBtn.setOpacity(0);
         tableBtn.setScale(1,0.7);
         tableBtn.visible = false;
         menu.addChild(tableBtn);
         
         backBtn = new cc.MenuItemImage(res.backBtn_n,res.backBtn_t, this.onButtonClick, this);
         backBtn.setName("BackBtn");
         backBtn.setPosition(cc.p(45, btnYpos));
         backBtn.setAnchorPoint(0.5,0.5);
         menu.addChild(backBtn);
         
         scoreBtn = new cc.MenuItemImage(res.scoreBtn_n,res.scoreBtn_t, this.onButtonClick, this);
         scoreBtn.setName("ScoreBtn");
         scoreBtn.setPosition(cc.p(visibleSize.width-260, btnYpos));
         menu.addChild(scoreBtn);
         
         hintToggleBtn = new cc.MenuItemToggle(new cc.MenuItemImage(res.hintBtn_n,res.hintBtn_s), new cc.MenuItemImage(res.hintBtn_s,res.hintBtn_n), this.onButtonClick, this);
         hintToggleBtn.setName("hintToggleBtn");
         hintToggleBtn.setPosition(cc.p(visibleSize.width-190, btnYpos));
         hintToggleBtn.setAnchorPoint(0.5,0.5);
         menu.addChild(hintToggleBtn);
         
         hintToggleBtn.setSelectedIndex(showHint?1:0);
         
         soundOnBtn = new cc.MenuItemImage(res.soundBtnOn_n,res.soundBtnOff_n, this.onButtonClick, this);
         soundOnBtn.setName("SoundOnBtn");
         soundOnBtn.setPosition(cc.p(visibleSize.width-50, btnYpos));
         soundOnBtn.setAnchorPoint(0.5,0.5);
         menu.addChild(soundOnBtn);
         
         soundOffBtn = new cc.MenuItemImage(res.soundBtnOff_n,res.soundBtnOn_n, this.onButtonClick, this);
         soundOffBtn.setName("SoundOffBtn");
         soundOffBtn.setPosition(cc.p(visibleSize.width-50, btnYpos));
         menu.addChild(soundOffBtn);
         
         speedBtn1 = new cc.MenuItemImage(res.speedBtn_1,res.speedBtn_2, this.onButtonClick, this);
         speedBtn1.setName("speedBtn1");
         speedBtn1.setPosition(cc.p(visibleSize.width-120, btnYpos));
         menu.addChild(speedBtn1);
         
         speedBtn2 = new cc.MenuItemImage(res.speedBtn_2,res.speedBtn_3, this.onButtonClick, this);
         speedBtn2.setName("speedBtn2");
         speedBtn2.setPosition(cc.p(visibleSize.width-120, btnYpos));
         menu.addChild(speedBtn2);
         
         speedBtn3 = new cc.MenuItemImage(res.speedBtn_3,res.speedBtn_1, this.onButtonClick, this);
         speedBtn3.setName("speedBtn3");
         speedBtn3.setPosition(cc.p(visibleSize.width-120, btnYpos));
         menu.addChild(speedBtn3);
         
         if(isDebugMode && showCardThrowBtn){
         button = new cc.MenuItemImage(res.rectImg,res.rectImg, this.onButtonClick, this);
         button.setName("throwCardBtn");
         button.setPosition(cc.p(visibleSize.width*0.75, visibleSize.height-160));
         menu.addChild(button);
         }
         
         speedBtn1.visible = true;
         speedBtn2.visible = false;
         speedBtn3.visible = false;
         
         soundOnBtn.visible = false;
         soundOffBtn.visible = false;
         
         //    	cc.log("------------------------------cardlayer>__gamePlaySpeed "+ __gamePlaySpeed);
         
         if(__gamePlaySpeed == speedVals.slow){
         speedBtn1.visible = true;
         }else if(__gamePlaySpeed == speedVals.normal){
         speedBtn2.visible = true;
         }else if(__gamePlaySpeed == speedVals.high){
         speedBtn3.visible = true;
         }
         
         if(playSfx){
         soundOnBtn.visible = true;
         }else{
         soundOffBtn.visible = true;
         }
         
         this.addChild(menu);
         menu.setPosition(0,0);
         //------------------------------------------
         
                 //---------------------------------------------
    	
                                 
                                 // create sprite sheet
    	cc.spriteFrameCache.addSpriteFrames(res.card_deck_plist);
    	this.cardTexture = cc.textureCache.addImage(res.card_deck_ss_img);

    	// creating multiple instances of the card
    	this._sprites = new cc.SpriteBatchNode(this.cardTexture);
    	this.addChild(this._sprites);

    	var cardsOrderByValueArr = [0,1,2,3,4,5,6,7,8,9,10,11,12];
    	cardsOrderByValueArr.reverse();
    	var cardsOrderBySuits = [Suits.Diamonds,Suits.Clubs, Suits.Hearts, Suits.Spades];
    	cardsOrderBySuits.reverse();

    	// creating cards
    	this.cardsArr = [];

    	var i, j, card, c= 0, t=0, pos;

    	for ( i = 0; i < 4; i++) 
    	{
    		for ( j = 0; j < 13; j++) 
    		{
    			card = new Card(cardsOrderBySuits[i], cardsOrderByValueArr[j]);
    			switch(dealTurnCount){
    			case 0:
    				//
    				pos = cc.p(visibleSize.width/2,visibleSize.height*0.18);
    				break;
    			case 1:
    				//
    				pos = cc.p(visibleSize.width*0.8,visibleSize.height*0.5);
    				break;
    			case 2:
    				//
    				pos = cc.p(visibleSize.width*0.5,visibleSize.height*0.8);
//                     pos = btnYpos+cardsi.height/2;
    				break;
    			case 3:
    				//
    				pos = cc.p(visibleSize.width*0.2,visibleSize.height*0.5);
    				break;	
    			}

    			card.setScale(cardsScaleVals.scaledDown);

    			card.setPosition(pos);

//    			if(t<51)
    			{
    				card.visible = false;
    			}
//    			else{
//    				card.visible = true;
//  				card.setScale(1);
////					card.setRotation(180);
////					card.setPositionY(card.getPositionY()-120);
//    			}

    			this.cardsArr[t]=card;
    			this._sprites.addChild(card);
//  			c+=0;
//  			card.setTag(t);
    			t++;
    		}
    	}
    	
//    	card = this.cardsArr[51];
//    	card.setScale(1);
////    	card.runAction(new cc.ScaleTo(tweenSpeed, cardsScaleVals.scaledDown).easing(easing));
//  	,
//  	new cc.ScaleTo(tweenSpeed, cardsScaleVals.scaledDown)
    	//----------
    	this.yourTurnLabel = new cc.LabelTTF("Your Turn!", boldFont, 36);
//  	this.yourTurnLabel.setColor(new cc.Color(255, 0, 0, 255));
    	this.yourTurnLabel.setPosition(cc.p(visibleSize.width/2-300, 170));
    	this.yourTurnLabel.visible = false;
    	this.addChild(this.yourTurnLabel);
    	//--------

//  	this.logLabel = new cc.LabelTTF("------------- log text --------------", normalFont, 20);
//    	this.logLabel.setAnchorPoint(0,0);
//    	this.logLabel.setPosition(cc.p(5, 250));
////  	this.logLabel.visible = false;
//    	this.addChild(this.logLabel);

    	var str = "";

//    	for(var key in cc.sys.capabilities) {
//    		cc.log("cc.sys.capabilities[" + key + "] : " + cc.sys.capabilities[key]);
//    	}

//  	this.logLabel.setString(str);
    	var justBacked = false;
    	var ref = this;
    	//add a keyboard event listener to statusLabel
    	var keyboardListener = cc.EventListener.create({
    		event: cc.EventListener.KEYBOARD,
    		onKeyPressed:  function(keyCode, event){
    			cc.log("key pressed: "+keyCode);
    			
//    			cardsLayer.logLabel.setString("key pressed: "+keyCode + " ");
    			if(keyCode == cc.KEY.backspace || keyCode == 6 && !justBacked && !ref.backConfirmNode.visible){
    				//do something
    				justBacked = true;
    				cardsLayer.onBack();
    				justBacked = false;
    			}
    		},
    		onKeyReleased: function(keyCode, event){
    			cc.log("key onKeyReleased: "+keyCode);

//    			cardsLayer.logLabel.setString("key pressed: "+keyCode + " ");
    			if(keyCode == cc.KEY.backspace || keyCode == 6 && !justBacked && !ref.backConfirmNode.visible){
    				//do something
    				justBacked = true;
    				cardsLayer.onBack();
    				justBacked = false;
    			}
    		}
    	});

    	cc.eventManager.addListener(keyboardListener, this);
//    	cc.log("cardslayer>playSfx: "+ playSfx + " showHint: "+showHint+ " mustHaveTrump: "+ mustHaveTrump+ " mustHaveFaceCard: "+ mustHaveFaceCard +" animateCardsDeal: "+ animateCardsDeal+ " __gamePlaySpeed: "+ __gamePlaySpeed);
    	
         //
         this.backConfirmNode = new cc.Node();
         
         //    	var rect = new cc.rect(0, 0, 102, 102);
         //    	var capInsets = new cc.rect(25, 25, 52, 52);
         
         this.bg = new cc.Sprite(res.popupBg2);
         
         this.bg.setTag(111);
         this.backConfirmNode.setPosition(visibleSize.width/2, visibleSize.height/2);
         
         this.confirmDBLabel	= new cc.LabelTTF("Do you want to go to main menu? You can continue the game session later!", normalFont, 32, cc.size(this.bg.getContentSize().width-5,140), cc.TEXT_ALIGNMENT_CENTER);
         this.confirmDBLabel.setPositionY(120);
         
         var okBtn = new cc.MenuItemImage(res.okBtn_n, res.okBtn_s, this.onButtonClick, this);
         okBtn.setName("backConfirmOk");
         okBtn.setPosition(150, 50);
         
         var cancelBtn 	= new cc.MenuItemImage(res.cancelBtn_normal,res.cancelBtn_touch, this.onButtonClick, this);
         cancelBtn.setName("backConfirmCancel");
         cancelBtn.setPosition(-150, 50);
         
         var adLabel	= new cc.LabelTTF("Enjoy playing our other game: ", normalFont, 32, cc.size(300,0), cc.TEXT_ALIGNMENT_CENTER);
         adLabel.setPosition(-140, -110);
         
         //    	var ludoDescLabel	= new cc.LabelTTF("Ludo Neo-Classic \n Nepali variant", normalFont, 36, cc.size(300,140), cc.TEXT_ALIGNMENT_CENTER);
         //    	adLabel.setPosition(-100, -150);
         
         var ludoBtn 	= new cc.MenuItemImage(res.ludo_icon,res.ludo_icon, this.onButtonClick, this);
         ludoBtn.setPosition(this.bg.getContentSize().width*0.20, adLabel.getPositionY());
         ludoBtn.setName("ludo");
         
         
         this.backConfirmNode.addChild(this.bg);
         this.backConfirmNode.addChild(this.confirmDBLabel);
         this.backConfirmNode.addChild(adLabel);
         
         var menu = new cc.Menu();
         menu.setPosition(0,0);
         menu.addChild(okBtn);
         menu.addChild(cancelBtn);
         menu.addChild(ludoBtn);
         
         this.backConfirmNode.addChild(menu);
         this.addChild(this.backConfirmNode);
         
         this.backConfirmNode.visible = false;
         
         if(isDebugMode){
         //    		this.addTouchEvent(this.bg);
         //    		cc.eventManager.pauseTarget(this.bg);
         }

    	//--------------------------------------------------------------------------------------------
    	
    	this.initDeal();
    	
    	if(isResume){
    		this.loadPreviousSession();
    		this.scheduleOnce(this.dealCards, 0.25);	
    	}else{
    		this.shuffleCards();
    		card = this.cardsArr[51];
    		card.setScale(1);
    		card.visible = true;
    		card.runAction(new cc.ScaleTo(tweenSpeed, cardsScaleVals.scaledDown).easing(easing));    		
    	}
    	
    	statusLayer.setRound(roundCount);
    	statusLayer.setTrump(Suits.Trump);
    	
    	if(!isResume){
    		this.scheduleOnce(this.dealCards, 0.5);	
    	}
         
    },
    showCallConfirm:function(){
//    	Exit from this session? Game progress will be lost!
    	if(scoresLayer.visible !=true || !winnerLayer.visible!=true)
    	{
    		this.backConfirmNode.visible = true;
    		this.backConfirmNode.setScale(0.4);

    		this.confirmDBLabel.setString("Your selected call is '"+ callPadLayer.selectedVal+"'!" + "\nPlease confirm to proceed?");
    		
    		var act = new cc.Spawn(
    				new cc.ScaleTo(0.15, 1),
    				new cc.FadeIn(0.15)).easing(easing);

    		this.backConfirmNode.runAction(act);

    		isWaiting = true;
    	}
    },
    onButtonClick:function(e){
        if(scoresLayer.visible !=true || !winnerLayer.visible!=true)
        {
            cc.log("onButtonClick ---"+ e.getName());
            if(e.getName() == "SoundOnBtn" || e.getName() == "SoundOffBtn" || e.getName() == "hintToggleBtn" || e.getName() == "speedBtn1" || e.getName() == "speedBtn2" || e.getName() == "speedBtn3" )
            {
                ls.setItem(Settings.customized, "customized");  
            }
            switch(e.getName()){
                case "SoundOnBtn":
                    playSfx = false;
                    soundOnBtn.visible = false;
                    soundOffBtn.visible = true;
                    ls.setItem(Settings.soundEffect, String(playSfx?1:0));
                    break
                case "SoundOffBtn":
                    playSfx = true;
                    soundOnBtn.visible = true;
                    soundOffBtn.visible = false;
                    ls.setItem(Settings.soundEffect, String(playSfx?1:0));
                    break	
                case "hintToggleBtn":
                    showHint = e.getSelectedIndex() == 1?true:false;
                    ls.setItem(Settings.showHint, String(e.getSelectedIndex()));
    //	    		if(showHint)
    //    			{
                        if(cardsOnFloor.length>0){
                            cardsLayer.showHints();
                        }
    //    			}else{
    //    				var i, len = otherCardsArr.length;
    //    				if(hintCardsArr.length>0 && len>0){
    //    					for(i=0; i<len; i++) {
    //    						otherCardsArr[i].runAction(new cc.TintTo(tweenSpeed/2, 255, 255, 255).easing(easing));
    //    						cc.eventManager.resumeTarget(otherCardsArr[i]);
    //    					}
    //    				}
    //    			}
                    break
                case "ScoreBtn":
                    cardsLayer.showScores();
                    break
                case "throwCardBtn":
                    cardsLayer.throwCard();
                    break	
                case "Mode":
                    showOpponentsCard = !showOpponentsCard;
                    var i, player, len;
                    for ( i = 1; i < 4; i++) {
                        player = playersArr[i];
                        len = player.cards.length;
                        for ( j = 0; j < len; j++) {
                            card = player.cards[j];
                            if(showOpponentsCard){
                                card.close();
                            }else{
                                card.open();
                            }
                        }
                    }
                    break	
                case "BackBtn":
                    this.onBack();
                    break
                case "speedBtn1":
                    //
                    __gamePlaySpeed = speedVals.normal;
                    speedBtn1.visible = false;
                    speedBtn2.visible = true;
                    speedBtn3.visible = false;
                    updateSpeedVal();
                    break	
                case "speedBtn2":
                    //
                    __gamePlaySpeed = speedVals.high;
                    speedBtn1.visible = false;
                    speedBtn2.visible = false;
                    speedBtn3.visible = true;
                    updateSpeedVal();
                    break
                case "speedBtn3":
                    //
                    __gamePlaySpeed = speedVals.slow;
                    speedBtn1.visible = true;
                    speedBtn2.visible = false;
                    speedBtn3.visible = false;
                    updateSpeedVal();
                     break; 
                case "backConfirmOk":
                    //
                    if(isBackPressed){
                        cc.director.runScene(new MainMenuScene());
                        isWaiting = false;
                        isBackPressed = false;
                    }else{
                        GameScene.onCallMade(callPadLayer.selectedVal);
                        callPadLayer.selectedVal = undefined;
                        this.backConfirmNode.visible = false;
        
        //    			backBtn.visible = true;
                    }
                    break;  
                case "backConfirmCancel":
                    //
        //    		this.backConfirmNode.visible = true;
        //    		this.backConfirmNode.setScale(0.4);
        
                    isBackPressed = false;
                    var act = new cc.Spawn(
                            new cc.ScaleTo(0.15, 0.2),
                            new cc.FadeOut(0.15)).easing(easing);
        
                    var seq = new cc.Sequence(act,new cc.CallFunc(function(){cardsLayer.backConfirmNode.visible = false;}));
                    
                    this.backConfirmNode.runAction(seq);

                    isWaiting = false;
                    break; 
                case "tableBtn":
                	cardsLayer.afterCheckCards();
                	break;      
                case "ludo":
    //	    		cc.log("openURL: "+ "market://details?id=com.veigar.ivernwpswpa");
                                 
                     if(cc.sys.os == cc.sys.OS_IOS)
                     {
                         cc.sys.openURL("https://itunes.apple.com/app/id1073309343");
                     }else{
                         cc.sys.openURL("market://details?id=com.veigar.ivernwpswpa");
                     }
                    break;  	
            }
        }
    },
    onBack:function(){
    	saveGameState();
    	isBackPressed = true;
    	if((scoresLayer.visible !=true || !winnerLayer.visible!=true) && backBtn.visible == true)
    	{
    		this.backConfirmNode.visible = true;
    		this.backConfirmNode.setScale(0.4);

    		this.confirmDBLabel.setString("Do you want to go to Main Menu? Still you can continue the game session later!");
    		
    		var act = new cc.Spawn(new cc.ScaleTo(0.15, 1),new cc.FadeOut(0.15).easing(easing));

    		this.backConfirmNode.runAction(act);

    		isWaiting = true;
    	}
    },
    loadPreviousSession:function()
    {
    	var savedDataArr = gameStateDataStr.split("~");
    	var playersDataArr = savedDataArr[0].split("|");
    	var cardsArr;
    	var tmpArr; 
    	var cardData;
    	var card;
    	var player;
    	var i,j,len;
    	
//    	cc.log("loadPreviousSession>savedDataArr "+savedDataArr);
//    	cc.log("loadPreviousSession>playersDataArr "+playersDataArr);
//    	cc.log("loadPreviousSession>gameStateDataStr "+gameStateDataStr);
    	
    	for(i=0; i<4; i++)
    	{
    		player = playersArr[i];    
    		cardsArr = playersDataArr[i].split(":");
    		if(cardsArr !=""){
//    			cc.log("cardsArr "+cardsArr + "  cardsArr "+cardsArr.length);
    			len = cardsArr.length;
    			for(j=0;j<len;j++)
    			{
    				tmpArr = cardsArr[j].split("-"); 
//    				cc.log("tmpArr "+tmpArr);
    				cardData = {suit:Number(tmpArr[0]),value:Number(tmpArr[1])};

    				card = this.getCardFromList(cardData.suit, cardData.value);
    				card.pid = i;
    				player.cards.push(card);
//    				cc.log("player.cards.push(card)");
    				totalCardsCount++;
    			} 
    		}
    	}
//    		cc.log("loadPreviousSession>player.cards "+player.cards.length);
    	//---------- cards on the floor -------

    	var cardsOnFloorTmp = savedDataArr[1].split(":");
//    	cc.log("loadPreviousSession>cardsOnFloorTmp "+cardsOnFloorTmp);
    	
    	if(cardsOnFloorTmp!=""){
    		len = cardsOnFloorTmp.length;
    		for(j=0; j<len; j++)
    		{
    			tmpArr 		= cardsOnFloorTmp[j].split("-"); 
    			cardData 	= {suit:Number(tmpArr[0]),value:Number(tmpArr[1]),pid:Number(tmpArr[2])};
    			card 		= this.getCardFromList(cardData.suit, cardData.value);
    			card.pid 	= cardData.pid;
    			cardsOnFloor.push(card);

    			if(card.pid == 0)
    			{
    				this.addTouchEvent(card);
//  				cc.eventManager.pauseTarget(card);
    			}else{
    				if(isDebugMode){
    					card.open();
    				}
    			}
    		}
    	}
        //---------------------------------------------------------

    	if(cardsOnFloor.length>0)
		{
    		curCardMove = cardsOnFloor[0];
            curCardOnFloor = cardsOnFloor[cardsOnFloor.length-1];
		}
    	//------- bid and hand 
    	
    	var bidHandValsArr = savedDataArr[2].split(":");
//    	cc.log("loadPreviousSession>bidHandValsArr "+bidHandValsArr + " length: "+bidHandValsArr.length);

    	if(bidHandValsArr!="" && bidHandValsArr.length>0)
    	{
	    	for(i=0; i<4; i++)
	    	{
	    		player = playersArr[i];
	    		if(bidHandValsArr[i]!=undefined)
	    		{	    				    			
		    		tmpArr = bidHandValsArr[i].split("-");
		    		player.hands = Number(tmpArr[0]);
		    		player.bidVal = Number(tmpArr[1]);
	    		}
	//  		cc.log("loadPreviousSession>player.cards "+player.cards.length);
	    	}
    	}
    	
    	if(!isNaN(Number(savedDataArr[4])))
		{
    		turnCount = Number(savedDataArr[4]);
		}
    	
    	if(!isNaN(Number(savedDataArr[5])))
    	{
    		throwCount = Number(savedDataArr[5]);	
    	}
    		
    	if(!isNaN(Number(savedDataArr[6])))
    	{
    		roundCount =  Number(savedDataArr[6]);
    	}    	    	
    	
//    	roundCount = scoresArr.length;
//    	cc.log("loadPreviousSession>turnCount: "+turnCount + " throwCount: "+throwCount+ " roundCount: "+roundCount);
    	
    	var scoreDataArr;
    	if(savedDataArr[3] != undefined){
    		scoreDataArr = savedDataArr[3].split("|");	
    	}
    	
    	if(scoreDataArr!="" && scoreDataArr!=undefined){
    		cc.log("loadPreviousSession>scoreDataArr: "+scoreDataArr + "\nscoreDataArr.length "+scoreDataArr.length);
    		scoresArr = [];
    		var len = scoreDataArr.length; 
    		for(i=0; i<len; i++)
    		{
    			tmpArr = scoreDataArr[i].split(":");
//    			cc.log("----------------scoreDataArr[i] ", scoreDataArr[i] +" tmpArr.length "+ tmpArr.length);
    			if(scoreDataArr[i]!="")
    			{
    				var sArr = [];
    				var score = "";
    				var lenn = tmpArr.length;
    				for(j=0; j<lenn; j++)
    				{
    					score = tmpArr[j];
    					sArr.push(Number(score));
    					
    					if(j<tmpArr.length-1){
    						scoreDataStr += score + ":"
    					}else{
    						scoreDataStr += score + "|"
    					}
    				}
    				scoresArr.push(sArr);
    			}
    		}
    	}
//    	cc.log("loadPreviousSeesion>scoreDataArr "+scoreDataArr);
//    	ls.setItem(Settings.scores, scoreDataStr);
//    	ls.setItem(Settings.roundCount, roundCount);
    	statusLayer.updateInfo();
    },
    initDeal:function()
    {
    	isPlaying = true;
    	isWaiting = true;
    	gameIsFinished = false;

    	//----------------- dividing cards ----------------

    	callTurnCount = turnCount+1;

    	if(callTurnCount>3){
    		callTurnCount = 0;
    	}
    	callMakingCount = 0;

    	cc.log("initDeal>callTurnCount: "+callTurnCount + " callMakingCount: "+callMakingCount);

    	var i, j, k;

    	var card = this.cardsArr[0], player;

    	var startPos, pos;

//  	cardSize = {width:card.getScale()*card.getContentSize().width, height:card.getScale()*card.getContentSize().height};
    	cardSize = getSizeByScale(card, cardsScaleVals.normal);

    	resizedCardSize = getSizeByScale(card, cardsScaleVals.scaledDown);

    	var startX = (visibleSize.width-((gapH*13)-gapH))*0.5;
    	var startY = marginV+cardSize.height*0.5;
    	var startX2 = marginH+cardSize.width*0.5;
    	var startY2 = (visibleSize.height-(gapV*13))*0.5+70;
    	//---- cards start and throw positions -------------

    	var bottomPos, leftPos, topPos, rightPos ;

    	if(isDebugMode){
    		bottomPos = cc.p(startX, startY);
    		leftPos = cc.p(startX2,visibleSize.height-startY2);
    		topPos = cc.p(startX,visibleSize.height-startY);
    		rightPos = cc.p(visibleSize.width-startX2, visibleSize.height-startY2);
    	}else{
    		bottomPos = cc.p(visibleSize.width/2,marginV+resizedCardSize.height*0.5);
    		leftPos =  cc.p(marginH+resizedCardSize.height*0.5,visibleSize.height/2);
    		topPos = cc.p(visibleSize.width/2,btnYpos);
    		rightPos = cc.p(visibleSize.width-marginH-resizedCardSize.height*0.5, visibleSize.height/2);
    	}

    	cardsStartPosArr = [bottomPos, rightPos, topPos, leftPos];
    	//=================================== creating players ========================================

    	for(i=0; i<4; i++)
    	{
    		player = new Player(cardsStartPosArr[i], i);            
    		player.name = playersNameArr[i];
    		playersArr[i] = player;
    	}
    	
    	curCardMove = undefined;
        curCardOnFloor = undefined;
        cardsOnFloor = [];
        totalCardsCount = 0;
        
        //-----------------------------------------------------------------------------------------------------
        
        cardsThrowPosArr = [];
        var diff = cardSize.height/2 - cardSize.width/2;
        var diff2 = cardSize.height*0.3;
        var overlap = 5;

        cardsThrowPosArr = [cc.p(visibleSize.width*0.5, visibleSize.height/2-(cardSize.height/2)+diff2),	
                                 cc.p(visibleSize.width*0.5+(cardSize.height-diff), visibleSize.height*0.5+diff),
                                 cc.p(visibleSize.width*0.5, visibleSize.height*0.5+(cardSize.height/2)+diff2-overlap*4),
                                 cc.p(visibleSize.width*0.5-(cardSize.height-diff), visibleSize.height*0.5+diff)];
    },
    getCardFromList:function(suit, value)
    {
//    	cc.log("getCardFromList "+suit +" "+ value );
    	var i,max = this.cardsArr.length, card, returnCard;
    	for(i=0;i<max;i++){
    		card = this.cardsArr[i];
    		if(card.suit == suit && card.value == value){
    			returnCard = card;
    			break;
    		}
    	}
    	if(returnCard!=undefined)
		{
//    		cc.log("getCardFromList>returnCard "+ returnCard.suit +":"+ returnCard.value);
		}
    	return returnCard;
    },
    shuffleCards:function(){
    	cc.log("shuffleCards");
//  	cc.log("creating players>i "+i + " t "+t + " turnCount "+ turnCount + " playersArr.length: "+playersArr.length);
		
    	totalCardsCount = 0;
    	
        //-------- dividing cards to the players ---
       
        // randomizing/shuffling cards
        randomizeArr(this.cardsArr);
        randomizeArr(this.cardsArr);
//      randomizeArr(this.cardsArr);
        
        var t = turnCount+1;
        var i,j;
        
        if(t>3)
        {
        	t = 0;
        }
        
        
        for(i=0; i<4; i++)
        {
        	player = playersArr[i];            
        	player.cards = [];
        }
        
		for (i=0; i<52; i++) 
		{
			card = this.cardsArr[i];
			card.pid = t;
//  			card.setLocalZOrder(i);
			player = playersArr[t];
			player.cardCount++;
			player.cards.push(card);
			t++;
			if(t>3){
				t = 0;
			}
			totalCardsCount++;
		}

//		for(i=0; i<4; i++)
//		{
//			player = playersArr[i];            
//			player.cards = player.cards.reverse();
//		}
        //------checking for spades and face card ------ 
        
        // sorting the cards of each player
        var __playerSpaceCount = 0;
        var __hasTrump = false;
        var __hasFaceCard = false;
        for(i=0; i<4; i++){
        	__hasTrump = false;
        	__hasFaceCard = false;
        	player = playersArr[i];
        	for ( j = 0; j < 13; j++) {
        		if(player.cards[j].suit == Suits.Trump){
        			if(!__hasTrump)
    				{
    					__hasTrump = true;
    				}
        		}  
        		
        		if(player.cards[j].value>9 && player.cards[j].value<12){
        			if(!__hasFaceCard)
        			{
        				__hasFaceCard = true;
        			}
        		} 
        		
        		if(j == 12)
        		{
	        		if(mustHaveTrump && mustHaveFaceCard)
	        		{
	        			if(__hasTrump && __hasFaceCard){
	        				__playerSpaceCount++;
	        				break;
	        			}
	        		}
	        		
	        		if(mustHaveTrump && !mustHaveFaceCard)
	        		{
	        			if(__hasTrump){
	        				__playerSpaceCount++;
	        				break;
	        			}
	        		}
	        		
	        		if(!mustHaveTrump && mustHaveFaceCard)
	        		{
	        			if(__hasFaceCard){
	        				__playerSpaceCount++;
	        				break;
	        			}
	        		}
	        		
	        		if(!mustHaveTrump && !mustHaveFaceCard)
	        		{
	//        			if(__hasFaceCard)
	        			{
	        				__playerSpaceCount++;
	        				break;
	        			}
	        		}
        		}
        		
        	}        	
        }
//        
        if(__playerSpaceCount<4){
        	cc.log("$$$$$$$$$$$$$$$$$$$$$$$ redeal cards!!! $$$$$$$$$$$$$$$$$$$$$$$$$");
        	this.shuffleCards(); 
        	return;
        }
    },
    dealCards:function(){
        thrownCardsArr = [];
        // sorting the cards of each player
    	var i,j,player, card, startPos,pos;
    	
       	for(i=0; i<4; i++)
        {
        	player = playersArr[i];
      		player.sortCards();
       	}

       	if(!isResume)
   		{
       		turnCount++;
       		if(turnCount>3){
       			turnCount = 0;
       		}
   		}
       	
        var c = 0;
        var that = this;
        var _gapH = (visibleSize.width-cardSize.width/2)/13;
        var _cardsWidth = _gapH*13 - _gapH
        var _startX = (visibleSize.width-_cardsWidth)/2;
        var _startY = cardSize.height*0.5;
        var len;
        
        var rotationValArr = [];
        
        if(isDebugMode)
        {
        	rotationValArr = [180,180,180,180];
        }else{
        	rotationValArr = [180,90,180,270];
        }       
    	
        if(animateCardsDeal && playSfx && !isResume){
        	this.scheduleOnce(function(){
        		cc.audioEngine.playEffect(res.cardDealSound);
        	}, 0.05);
        }	
        
        for ( i = 0; i < 4; i++)
        {
            player = playersArr[i];
           
//            cc.log("dealCards>player.cards.length: ", player.cards.length);
            len = player.cards.length;
            for ( j = 0; j < len; j++) {
                card = player.cards[j];
	           	startPos = player.startPos;
	           	
	           	switch (i){
	               case 0:
	//                 //	            	   	            	   	            	 	            	  
	            	   pos = cc.p(visibleSize.width/2, startPos.y);
	            	   
	                   if(!animateCardsDeal){
	                        card.open();
	                   }
	                   break;
	               case 1:
	                   //
	            	   if(isDebugMode){
	            		   pos = cc.p(startPos.x, startPos.y-j*gapV);   
	            	   }else{
	            		   pos = cc.p(startPos.x, visibleSize.height/2);
	            	   }
	                  
	                   break;
	               case 2:
	                   //
	            	   if(isDebugMode){
	            		   pos = cc.p(startPos.x+j*gapH, startPos.y);
	            	   }else{
	            		   pos = cc.p(visibleSize.width/2, startPos.y);
//                            pos = btnYpos;
	            	   }
	                   break;
	               case 3:
	                   //
	            	   if(isDebugMode){
	            		   pos = cc.p(startPos.x, startPos.y-j*gapV);
	            	   }else{
	            		   pos = cc.p(startPos.x, visibleSize.height/2);
	            	   }
	                   break;
	           	}
	           
	           // dividing/positioning the cards to the players' side

	           	var onFinishFunc = function(tar){
//	           		cc.log("onFinishFunc ");
	           		
	           		if(tar.pid == 0)
	           		{
	           			if(isResume)
	           			{
	           				tar.open();
	           			}
	           			
	           			that.addTouchEvent(tar);
	           			cc.eventManager.pauseTarget(tar);
	           		}else{
	           			if(isDebugMode){
	           				tar.open();
	           			}
	           		}
	           		c++;

//	           		cc.log("onFinishFunc  " + c+"/" +totalCardsCount);
	           		
	           		if(c == totalCardsCount){
	           			cc.log("dealcards done " + totalCardsCount);
	           			statusLayer.visible = true;
	           			that.spreadMyCards();
	           			if(cardsOnFloor.length==0)
           				{
           					setTimeout(that.makeCall, showCardsTill+timeoutTime);
           				}else{
//           				var moveAct = new cc.MoveTo(tweenSpeed, cardsThrowPosArr[_card.pid]);
           					// positioning cardsOnFloor
           					cc.log("game resume>positioning cardsOnFloor");
           					var i,len=cardsOnFloor.length,card;
           					for(i=0; i<len; i++){
           						
           						card = cardsOnFloor[i];
           						card.visible = true;
           						card.setScale(cardsScaleVals.normal);
           						card.setPosition(cardsThrowPosArr[card.pid]);
           						card.setRotation(rotationValArr[card.pid]);
         						card.open();
           					}
           					isWaiting = false;
//           				setTimeout(cardsLayer.throwCard, timeoutTime);
           					cardsLayer.scheduleOnce(cardsLayer.popUp, tweenSpeed);
           					setTimeout(cardsLayer.showHints, tweenSpeed*1000);
           				}
	           		}
	           	};
	           
//	           	cc.log("dealCards-----");
	           	
	           	if(!isResume)
           		{
		           	if(animateCardsDeal)
		           	{
		               var spawnActs = [];
		               var moveAct = new cc.MoveTo(dealAnimSpeed, pos);
		               var rotateAct = new cc.RotateBy(dealAnimSpeed, rotationValArr[i]);
		               var scaleAct ;
		               
		               if(isDebugMode){
		            	   scaleAct = new cc.ScaleTo(dealAnimSpeed, cardsScaleVals.normal);
		               }else{
		            	   scaleAct = new cc.ScaleTo(dealAnimSpeed, cardsScaleVals.scaledDown);
		               }
		               
	//				   var bezierAct = new cc.BezierTo(0.5, [cc.p(visibleSize.width/2, visibleSize.height / 2), cc.p(visibleSize.width/2, visibleSize.height*0.75), pos]);
					   
		               spawnActs = [moveAct, scaleAct, rotateAct];
					
		               //--------------------------------
					   card.visible = true;
		               card.runAction(new cc.Sequence(
				         				   new cc.DelayTime(dealAnimSpeed/10*j),
				         				   new cc.Spawn(spawnActs).easing(easing),
				         				   new cc.CallFunc(onFinishFunc, that, card)
		                   			));
		           	}else{
		           		if(i!=0){
		           			card.setPosition(pos);
		           			card.setScale(cardsScaleVals.scaledDown);
		           		}else{
		           			card.setScale(cardsScaleVals.normal);
		           		}

		           		card.visible = true;
		           		onFinishFunc(card);
		           	}
				}else{
					if(i!=0){
						card.setPosition(pos);
						card.setScale(cardsScaleVals.scaledDown);
					}else{
						card.setScale(cardsScaleVals.normal);
					}
					
					card.setRotation(rotationValArr[i]);
					
					card.visible = true;
					onFinishFunc(card);
				}
	           //-----
        	}
    	}
        if(!animateCardsDeal) {
        	statusLayer.visible = true;
        	setTimeout(this.makeCall,timeoutTime,0);
        }
//        saveGameState();
        //----------
                                 
//         sdkbox.PluginApteligent.setValueforKey(roundCount, "Game Round");
    },
    addTouchEvent:function(_target){
        var listener = cc.EventListener.create({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            // When "swallow touches" is true, then returning 'true' from the onTouchBegan method will "swallow" the touch event, preventing other listeners from using it.
            swallowTouches: true,
            //onTouchBegan event callback function
            onTouchBegan: function (touch, event) {
                // event.getCurrentTarget() returns the *listener's* sceneGraphPriority node.
            	var target = event.getCurrentTarget();
//            	cc.log("onTouchBegan");
            	if(target.getTag() == 111){
            		return true;
            	}else{
            		//Get the position of the current point relative to the button
            		var locationInNode = target.convertToNodeSpace(touch.getLocation());
            		var s = target.getContentSize();
            		var rect = cc.rect(0, 0, s.width, s.height);

            		curCardTouchPos = locationInNode;
            		//Check the click area
            		if (cc.rectContainsPoint(rect, locationInNode))
            		{
            			target.setScale(cardsScaleVals.scaledUp);
//            			target.setPositionY(target.getPositionY()+10);
            			curCardTouchPos = touch.getLocation();
            			//----- checking card move eligility
            			
            			var card = target;
//            			if(!callPadLayer.visible && !isWaiting)
            			{
            				if(hintCardsArr.length>0){			
            					if(!containsCardInArr(card, hintCardsArr) && !showHint){
            						isNopeCard = true;
            						cc.log("Illegal move!!!" + card.pid + " s: "+card.suit +" v: "+ card.value + " isNopeCard: "+ isNopeCard);
            						var origPos = card.getPosition();
            						var nopAct = new cc.Sequence(new cc.MoveBy(tweenSpeed/2, cc.p(20, 0)).easing(cc.easeBounceIn()), new cc.MoveBy(tweenSpeed/2, cc.p(-20, 0)).easing(cc.easeBounceOut()));
            						card.runAction(nopAct);

            						if(playSfx)
            						{
            							cc.audioEngine.playEffect(res.wrongMoveSound);
            						}    				
            					}  
            				}
            			}
            			
            			return true;
            		}else{
            			return false;
            		}
            	}
            },
            //Trigger when moving touch
	        onTouchMoved: function (touch, event) {
	            //Move the position of current button sprite
	            var target = event.getCurrentTarget();   
	            
	            if(tapToThrow)
	            {
	            	return false;
	            }
	            if(!isNopeCard)
	            {
	            	target.setPositionY(touch.getLocationY());
//	            	cc.log("target.getPositionY() "+ target.getPositionY());
//	            	cc.log("onTouchMoved>isNopeCard: "+ isNopeCard);
	            }
	            
	            if(target.getPositionY()>200 && !isNopeCard)
	            {
	            	if(target.getTag() == 111){
	            		if(!callPadLayer.visible && turnCount!=0)
	            		{
	            			cardsLayer.throwCard();
	            		}
	            		return true;
	            	}else{
	            		var s = target.getContentSize();
//	            		var rect = cc.rect(0, 0, s.width, s.height);

	            		target.setScale(cardsScaleVals.normal);
//	            		target.setPositionY(target.getPositionY()-10);
	            		//-------------------
//	            		var dx = curCardTouchPos.x - touch.getLocation().x;
//	            		var dy = curCardTouchPos.y - touch.getLocation().y;

//	            		var dis = Math.round(Math.sqrt((dx*dx) + (dy*dy)));

//	            		if (Math.abs(dis) < 30) {
	            			if(!isWaiting){
	            				cardsLayer.onCardTouch(target);
	            				return true;
	            			}else{
	            				return false;
	            			}
//	            		} else {
//	            			return false;
//	            		}
	            	}
	            }
	        },
            //Process the touch end event
            onTouchEnded: function (touch, event) {
                var target = event.getCurrentTarget();
                
                if(tapToThrow)
            	{
                	if(target.getTag() == 111){
                		if(!callPadLayer.visible && turnCount!=0)
                		{
                			cardsLayer.throwCard();
                		}
                		return true;
                	}else{
                		var s = target.getContentSize();
//              		var rect = cc.rect(0, 0, s.width, s.height);

                		target.setScale(cardsScaleVals.normal);
                		//-------------------
                		var dx = curCardTouchPos.x - touch.getLocation().x;
                		var dy = curCardTouchPos.y - touch.getLocation().y;

                		var dis = Math.round(Math.sqrt((dx*dx) + (dy*dy)));

                		if (Math.abs(dis) < 30) {
                			if(!isWaiting){
                				cardsLayer.onCardTouch(target);
                				return true;
                			}else{
                				return false;
                			}
                		} else {
                			return false;
                		}
                	}
            	}else{
            		if(target.getPositionY()<=200)
            		{
//          			target.setScale(cardsScaleVals.normal);
//          			target.setPositionY(cardSize.height*0.5);
            			var pos = cc.p(target.getPositionX(), cardSize.height*0.5);
            			var moveAct = new cc.MoveTo(tweenSpeed/2, pos).easing(easing);
            			var scaleAct = new cc.ScaleTo(tweenSpeed/2, cardsScaleVals.normal).easing(easing);

            			target.runAction(new cc.Spawn([moveAct,scaleAct]).easing(easing));
            		}
            	}
                //Get the position of the current point relative to the button
//                target.setPositionY(target.getPositionY()-8);
//              cc.log("onTouchEnded");
           
                isNopeCard = false;
            }
	        //---
        });

        if(_target.getTag() == 0){
        	cc.eventManager.addListener(listener, _target);
        }else{
        	cc.eventManager.addListener(listener.clone(), _target);
        }
    },
    onCardTouch:function(card){
//    	cc.log("onCardTouch>pid: "+ card.pid + " s: "+card.suit +" v: "+ card.value + " hintCardsArr.length: "+hintCardsArr.length);
    	//--- checking if the card move is correct or not ------    	
    	if(!callPadLayer.visible && !isWaiting){
    		if(hintCardsArr.length>0){			
    			if(containsCardInArr(card, hintCardsArr)){
    				clearTimeout(showHintTimeoutId);
	    			selectedCard = card;
	    			cardsLayer.throwCard();
	    			hintCardsArr = [];
    			}else{
//    				cc.log("Illegal move!!!" + card.pid + " s: "+card.suit +" v: "+ card.value );
//    				var origPos = card.getPosition();
//    				var nopAct = new cc.Sequence(new cc.MoveBy(tweenSpeed/2, cc.p(20, 0)).easing(cc.easeBounceIn()), new cc.MoveBy(tweenSpeed/2, cc.p(-20, 0)).easing(cc.easeBounceOut()));
//    				card.runAction(nopAct);
//    				if(playSfx)
//    				{
//    					cc.audioEngine.playEffect(res.wrongMoveSound);
//    				}    				
    			}  
    		}else{
    			selectedCard = card;
    			cardsLayer.throwCard();
    			hintCardsArr = [];    			
    		}  
    		cardsLayer.yourTurnLabel.visible = false;
    	}
    },
    throwCard:function(){
    	cardsLayer.enableTouch(false);
//    	cc.log("throwCard>turnCount " + turnCount + " selectedCard:" +selectedCard);
		isWaiting = false;
		
		//------------
		var that = this;
		var i = 0, _card;	
		
		if(cardsOnFloor.length<4){
			// human player
			if(turnCount == 0){
				if(selectedCard !=undefined){
					_card = playersArr[turnCount].getCard(selectedCard);
					selectedCard = undefined;
				}else{
					if(throwCount == 12)
					{
						cardsLayer.enableTouch(false);
//						cc.log("+++++++++++++++++++++++++++++++++++++++++++ auto throw last card 2");
						_card = playersArr[turnCount].getCard(0);
					}else{
						cardsLayer.scheduleOnce(cardsLayer.popUp, tweenSpeed);
					}
				}
			}else{
				if(curCardMove == undefined){
//					cc.log("throwcard, getting random card");
					_card = playersArr[turnCount].getCard(true);
				}else{
//					cc.log("+++++++++++++++++++++++++++++++++++++++++++ auto throw last card 3");
					_card = playersArr[turnCount].getCard();	
				}	
				if(_card !=undefined){
					_card.open();
				}
			}			
//			cc.log("----------------throwCard>cardsOnFloor.length: "+cardsOnFloor.length + " _card: "+_card);
			if(_card !=undefined){
				curCardOnFloor = _card;
				cardsOnFloor.push(_card);
				thrownCardsArr.push(_card);
				
				if(cardsOnFloor.length==1){
					curCardMove = cardsOnFloor[0];
				}
		
				statusLayer.setCurSuit(curCardMove.suit);
				
	//			cc.log("curCardMove " +curCardMove.pid);
				// cc.log("_card.pid "+_card.pid);
				
				if(playSfx){
					cc.audioEngine.playEffect(res.cardThrowSound);
				}
				var spawnActs = [];
				var moveAct = new cc.MoveTo(tweenSpeed, cardsThrowPosArr[_card.pid]);
//					var fadeAct = new cc.FadeIn(tweenSpeed);
				var rotateAct = new cc.RotateBy(tweenSpeed, 180);
				var scaleAct = new cc.ScaleTo(tweenSpeed, cardsScaleVals.normal);
				
				if(isDebugMode){
					spawnActs = [moveAct,rotateAct];
				}else{
					spawnActs = [moveAct,scaleAct,rotateAct];
				}
//				var seq = new cc.Sequence(new cc.Spawn(spawnActs).easing(easing), new cc.DelayTime(tweenSpeed/2), new cc.CallFunc(cardsLayer.reArrangeCards));
				_card.runAction(new cc.Spawn(spawnActs).easing(easing));
//				_card.runAction(seq);
				
				setTimeout(cardsLayer.reArrangeCards, tweenSpeed*1*1000);
				//-----------------------------------------------------------------------
				turnCount++;
				if(turnCount>3){
					turnCount = 0;
					cc.log("~~~~~~~~~~~~~~~~~~~~~~throwcard>curCardMove.pid: "+ curCardMove.pid + "   throwCount:  "+throwCount);
					if(curCardMove.pid != 0 && throwCount <13)
					{
						if(throwCount == 12){
							cardsLayer.enableTouch(false);
//							cc.log("+++++++++++++++++++++++++++++++++++++++++++ auto throw last card 4");
//							selectedCard = playersArr[turnCount].getCard(0);
							cardsLayer.scheduleOnce(cardsLayer.throwCard, tweenSpeed);
						}else
						{
							cc.log("throwcard>throwCount else -----: "+ throwCount);
							cardsLayer.scheduleOnce(cardsLayer.popUp, tweenSpeed);
							setTimeout(cardsLayer.showHints, tweenSpeed*1000);
						}
					}
				}
				
				if(turnCount!=0)
				{
					isWaiting = true;
					if(isDebugMode){
						if(!showCardThrowBtn){
							setTimeout(cardsLayer.throwCard, timeoutTime);
						}
					}else{
						setTimeout(cardsLayer.throwCard, timeoutTime);
					}
				}
				
				if(cardsOnFloor.length == 4){
					cardsLayer.checkCardsOnFloor();
				}
			}
		}
//		saveGameState();
	},
	popUp:function (){
		cardsLayer.yourTurnLabel.visible = true;
		var seq = new cc.Sequence(
				new cc.ScaleTo(0.15, 1.25),
				new cc.CallFunc(saveGameState, this),
				new cc.DelayTime(0.5),
				new cc.ScaleTo(0.15,1));
		cardsLayer.yourTurnLabel.runAction(new cc.Repeat(seq,1));
		cardsLayer.enableTouch();
	},
	checkCardsOnFloor:function(){
		cc.log("checkCardsOnFloor");
		isWaiting = false;
		//----------------------------------------------------
		var i = 0, _card;				
		//---- winner card checking ----------------	
		if(isDebugMode && is8BidWinTestMode && throwCount<9){
			var i, len = cardsOnFloor.length;
			for(i=0; i<len; i++){
				if(cardsOnFloor[i].pid == 0){
					winnerCard = cardsOnFloor[i];
					break;
				}
			}
		}else{
			if(curCardMove.suit!=Suits.Trump){
				if(hasTrump(cardsOnFloor)){
					winnerCard = getMaxCardBySuit(Suits.Trump, cardsOnFloor);
				}else{
					winnerCard = getMaxCardBySuit(curCardMove.suit, cardsOnFloor);
				}
			}else{
				winnerCard = getMaxCardBySuit(Suits.Trump,cardsOnFloor);
			}
		}

//		console.log("winnerCard>suit: "+ winnerCard.suit +" val: " +winnerCard.value +" pid: "+ winnerCard.pid);
		//------------------------------------------		
//		cc.log("checkCardsOnFloor>winnerCard: "+winnerCard);
		
		turnCount = winnerCard.pid;
		
		var bottomHandPos = cc.p(visibleSize.width/2, -80);
		var leftHandPos = cc.p(-60,visibleSize.height/2);
		var topHandPos = cc.p(visibleSize.width/2, visibleSize.height+80);
		var rightHandPos = cc.p(visibleSize.width+60,visibleSize.height/2);
		
		var cardsHandPosArr = [bottomHandPos,rightHandPos,topHandPos,leftHandPos];
		//-------------
		isWaiting = true;
		
		var rotVal;
		
		if(tapToClearFloor)
		{
			tableBtn.visible = true;
		}else{
			setTimeout(cardsLayer.afterCheckCards, showCardsTill);
		}		
	},
	afterCheckCards:function(){
		var rotationValArr;

		if(isDebugMode){
			rotationValArr = [180,180,180,180];
		}else{
			rotationValArr = [180,90,0,90];
		}

		var that = this;
		var i, len = cardsOnFloor.length;
		for(i=0; i<len; i++){
			_card = cardsOnFloor[i];
			rotVal = rotationValArr[winnerCard.pid];

//			cc.log( "----------- _card.getRotation(): " + _card.getRotation() + " pid: "+ _card.pid);
			if(winnerCard.pid%2 == 1){
				if(_card.pid%2==0){
					rotVal = 90;
				}else{
					rotVal = 180;
				}
			}else{
				if(_card.pid%2==1){
					rotVal = 90;
				}else{
					rotVal = 180;
				}
			}
			_card.runAction(new cc.Sequence(
					new cc.Spawn(new cc.MoveTo(tweenSpeed,  cardsStartPosArr[winnerCard.pid]),
							new cc.RotateBy(tweenSpeed, rotVal)
//					new cc.FadeOut(tweenSpeed)
					).easing(easing),
					new cc.CallFunc(onFinishFunc, that, _card)
			));	
			cc.eventManager.removeListeners(_card);
		};

		function onFinishFunc(tar){
			cardsLayer._sprites.removeChild(tar,true);
//			cc.log("onFinishFunc "+tar.suit +" "+ tar.value);
		}
		//----------
		statusLayer.setCurSuit(-1);
		playersArr[turnCount].hands++;
		statusLayer["setHands"](playersArr[turnCount].hands);
		cardsOnFloor = [];
		curCardOnFloor = undefined;
		curCardMove = undefined;
		selectedCard = undefined;
		isWaiting = false;
		//-----------------------------------------------------------------------
		throwCount++;

		if(throwCount == 13){
			isPlaying = false;
			setTimeout(cardsLayer.showScores, timeoutTime);
		}else{
			if(turnCount!=0)
			{
				setTimeout(cardsLayer.throwCard, timeoutTime*2);
			}else{
				if(throwCount == 12){
					cardsLayer.enableTouch(false);
//					cc.log("+++++++++++++++++++++++++++++++++++++++++++ auto throw last card 3");
					cardsLayer.scheduleOnce(cardsLayer.throwCard, tweenSpeed);
				}else
				{
					cardsLayer.scheduleOnce(cardsLayer.popUp, tweenSpeed);
				}
			}
		}
		tableBtn.visible = false;
	},
	reArrangeCards:function () {
		var player, card, j, pos, len, startPos;
		
		player = playersArr[curCardOnFloor.pid];	
		
		len = player.cards.length;
		
//		cc.log("reArrangeCards>player.id: "+curCardOnFloor.pid+ " "+player.id + " len: "+len);
		
		//--------------------------------------------------
		
		var startX = (visibleSize.width-((gapH*len)-gapH))*0.5;
		var startY = marginV+cardSize.height*0.5;
		var startX2 = marginH+cardSize.width*0.5;
		var startY2 = (visibleSize.height-gapV*len)*0.5 + 70;

		//---- cards start and throw positions -------------
		var startPosArr = [];
		
		if(isDebugMode){
			bottomPos = cc.p(startX, startY);
			leftPos =  cc.p(startX2,visibleSize.height-startY2);
			topPos = cc.p(startX,visibleSize.height-startY);
			rightPos = cc.p(visibleSize.width-startX2, visibleSize.height-startY2);
		}else{
			bottomPos = cc.p(startX, startY);
			leftPos =  cc.p(marginH+resizedCardSize.height*0.5,visibleSize.height/2);
			topPos = cc.p(visibleSize.width/2,visibleSize.height-resizedCardSize.height-35);
//            topPos = btnYpos;
			rightPos = cc.p(visibleSize.width-marginH-resizedCardSize.height*0.5, visibleSize.height/2);
		}
		
		startPosArr = [bottomPos,rightPos,topPos,leftPos];
		
//		cc.p(startX2,visibleSize.height-startY2)
		startPos = cardsStartPosArr[player.id];
//		startPos = startPosArr[player.id];
		
		var _gapH;
		
		if(isDebugMode){
			_gapH = (visibleSize.width-cardSize.width/2)/16;
		}else{
//			_gapH = (visibleSize.width-cardSize.width/2)/13;
			
//			_gapH = cardSize.width+1;
			if(playersArr[0].cards.length<=10){
				_gapH = (visibleSize.width-cardSize.width/2)/10;
			}else{
				_gapH = (visibleSize.width-cardSize.width/2)/playersArr[0].cards.length;
			}			
		}
		
		var _cardsWidth = _gapH*len - _gapH
		var _startX = (visibleSize.width-_cardsWidth)/2;
		var _startY = cardSize.height*0.5;
		
		//-----------------------------------------------------
		for (j=0; j<len; j++) 
		{
			card = player.cards[j];
			switch (player.id){
				case 0:
				//
					pos = cc.p(_startX+j*_gapH, _startY);				
					break;
				case 1:
					//
					if(isDebugMode){
						pos = cc.p(startPos.x, startPos.y-j*gapV);
					}else{
//						pos = cc.p(startPos.x, visibleSize.height/2-j*1);
						pos = cc.p(startPos.x, visibleSize.height/2);
					}

					break;
				case 2:
					//
					if(isDebugMode){
						pos = cc.p(startPos.x+j*gapH, startPos.y);
					}else{
//						pos = cc.p(visibleSize.width/2+j*1, startPos.y);
						pos = cc.p(visibleSize.width/2, startPos.y);
					}
					break;
				case 3:
					//
					if(isDebugMode){
						pos = cc.p(startPos.x, startPos.y-j*gapV);
					}else{
//						pos = cc.p(startPos.x, visibleSize.height/2-j*1);
						pos = cc.p(startPos.x, visibleSize.height/2);
					}
					break;
			}
			
//			if(animateCardsDeal){
				card.runAction(new cc.Spawn(
						new cc.MoveTo(tweenSpeed, pos),
						new cc.TintTo(tweenSpeed/2, 255,255,255)).easing(easing));
//			}else{
//				card.setPosition(pos);
//				card.setColor(cc.color(255,255,255));
//			}
			cc.eventManager.resumeTarget(card);
		}	
	},
	spreadMyCards:function(){
		cc.log("--------------------------------spreadMyCards");
		var player = playersArr[0];
		var len = player.cards.length;
		var card, j;
		
		var _gapH;
		
		if(isDebugMode){
			_gapH = (visibleSize.width-cardSize.width/2)/16;
		}else{
			_gapH = (visibleSize.width-cardSize.width/2)/13;
		}
		var _cardsWidth = _gapH*len - _gapH
		var _startX = (visibleSize.width-_cardsWidth)/2;
		var _startY = cardSize.height*0.5;
		var pos, pos2;
		var seq;
		var spreadAct;
		var grabAct;
		var spawnAct;
		
		for (j=0; j<len; j++) {
			card = player.cards[j];
//			card.open();
			pos = cc.p(card.getPositionX(), -cardSize.height);	
			pos2 = cc.p(_startX+j*_gapH, _startY);
			
			grabAct = new cc.MoveTo(tweenSpeed, pos).easing(easing);
			spreadAct = new cc.MoveTo(tweenSpeed, pos2).easing(easing);
			
			scaleAct = new cc.ScaleTo(tweenSpeed, cardsScaleVals.normal).easing(easing);
			
			if(isDebugMode ){
				seq = new cc.Sequence(grabAct, spreadAct);
			}else{
				
				seq = new cc.Sequence(grabAct, new cc.Spawn(scaleAct,spreadAct));
			}
			if(!isResume){
				card.runAction(seq);
			}else{
				card.setPosition(pos2);
			}
		}
		
		setTimeout(this.openMyCards, timeoutTime);
	},
	openMyCards:function(){
		cc.log("--------------------------------openMyCards");
		var player = playersArr[0];
		var len = player.cards.length;
		var card, j;

		for (j=0; j<len; j++) {
			card = player.cards[j];
			card.open();
		}
	},
	playNextRound:function () {
		isResume = false;
		dealTurnCount++;
		if(dealTurnCount>3){
			dealTurnCount = 0;
		}
		//-----------------------------------------------------
		if(gameIsFinished){
			roundCount = 0;
			scoresArr = [];
			cc.director.runScene(new MainMenuScene());
		}else{
			if(roundCount<=roundNum){
				cc.director.runScene(new GameScene());
			}else{
				roundCount = 0;
				scoresArr = [];
				cc.director.runScene(new MainMenuScene());
			}
		}
	},
	showScores:function(){
		cc.log("showScores>throwCount: "+throwCount);
		if(isPlaying){
			scoresLayer.visible = !scoresLayer.visible;
		}else{
			
			cardsLayer.yourTurnLabel.visible = false;
			if(roundCount < roundNum){
				// check for 8 bid win 
				var i;
				for(i=0; i<4; i++){
					if(playersArr[i].bidVal>=8 && playersArr[i].hands>=playersArr[i].bidVal){
						winnerLayer.showWinner(playersArr[i].name);
						winnerLayer.visible = true;
						statusLayer.visible = false;
						ls.setItem("gameState", "");
						break;
					}
				}
				
				scoresLayer.updateScores();	
				scoresLayer.visible = true;
				statusLayer.visible = false;
			}else{
				scoresLayer.updateScores();	

				var maxValIndex = getMaxValIndex(totalScoresArr);
				
//				cc.log("showScores>maxValIndex: "+maxValIndex + " totalScoresArr: "+totalScoresArr.length);
				cc.log("The winner is "+playersArr[maxValIndex].name + "!!!");

				winnerLayer.showWinner(playersArr[maxValIndex].name);
				winnerLayer.visible = true;
				statusLayer.visible = false;

				ls.setItem("gameState", "");
//				setTimeout(function(){
//					scoresLayer.visible = true;
//					winnerLayer.visible = false;
//				}, showCardsTill*4);
			}
			// for testing leadbolt ad
//             cc.log("sdkbox.PluginLeadBolt.isAdReady: "+sdkbox.PluginLeadBolt.isAdReady("directdeal"));
//             if(sdkbox.PluginLeadBolt.isAdReady("directdeal"))
//             {
//                 sdkbox.PluginLeadBolt.loadModule("directdeal");
//             }
//             sdkbox.PluginAdMob.show("round_fs");
                                             
             var showAdOnThree = false;
             
            // showing interstitial ad in roundCount 3 or 8
             if((roundCount-3)%5 == 0)
             {
                 var showAdOnThreeProbsList = [1,1,0,0,0];
                
                 var rnd = Math.floor(Math.random()*showAdOnThreeProbsList.length);
                 showAdOnThree = showAdOnThreeProbsList[rnd] == 1?true:false;
             }
             
             if(showAdOnThree)
             {
//                  var adPrioList = ["admob", "admob", "leadBolt"];
//                  var rndNum = Math.floor(Math.random()*adPrioList.length);
//                  var showLeadBoltAd = adPrioList[rndNum] == "leadBolt"?true:false;
                  
//                 cc.log("showAdOnThree>showLeadBoltAd: " +showLeadBoltAd);
//                 if(showLeadBoltAd && sdkbox.PluginLeadBolt.isAdReady("directdeal"))
//                 {
//                     sdkbox.PluginLeadBolt.loadModule("directdeal");
//                 }else{
                     sdkbox.PluginAdMob.show("round_fs");
//                 }
             }
             if(roundCount%5 == 0)
             {
                 sdkbox.PluginAdMob.show("round_fs");
             }

			roundCount++;
						
			playersArr = [];
			totalScoresArr = [];
			throwCount = 0;
			
		}
	},
	makeCall:function(val) {
		//human player's turn
//		cc.log("makeCall>callMakingCount: " +callMakingCount + " callTurnCount: "+callTurnCount + " val: "+val);
        if(callMakingCount<4){        	
        	if(callTurnCount == 0){
//        		if(!callPadLayer==undefined || callPadLayer.visible && val == undefined){
        		if(val == undefined){
        			isWaiting = false;
        			GameScene.showCallPad(true);
        		}else{
        			playersArr[callTurnCount].bidVal = val;
        			statusLayer.setCalls();
        			callPadLayer.visible = false; 
        			callMakingCount++;
        			callTurnCount++;
        			if(callTurnCount>3){
        				callTurnCount = 0;
        			}
//        			cc.eventManager.resumeTarget(cardsLayer.bg);
        			setTimeout(cardsLayer.makeCall, timeoutTime*2);
        		}
        	}else{
        		// AI part... calculating the call/bid
//        		playersArr[callTurnCount].bidVal = getRandomNumInRange(2,6,true);
        		playersArr[callTurnCount].bidVal = playersArr[callTurnCount].getEstimatedBid();
        		
        		statusLayer.setCalls();
        		//-----------------------
        		setTimeout(cardsLayer.makeCall, timeoutTime*2);
        		callMakingCount++;
        		callTurnCount++;
        		if(callTurnCount>3){
        			callTurnCount = 0;
        		}
        	}
        }else{        	
            setTimeout(cardsLayer.throwCard, timeoutTime);
            callMakingCount = 0;
        } 
        saveGameState();
	},
	showHints:function(){
		var _cardsArr = playersArr[0].cards;
		
//		_cardsArr = _cardsArr.reverse();
		var cardsBySuitArr = [];
		var maxCardsArr = [];
		var curMaxCard;			
		
		hintCardsArr = [];
		
		// getting current max card on the floor of led suit
		curMaxCard = getMaxCardBySuit(curCardMove.suit, cardsOnFloor);
		
//		cc.log("1 showHints>curMaxCard: "+ curMaxCard.suit + " / "+ curMaxCard.value);
		
		if(curCardMove.suit == Suits.Trump){
			// getting greater cards list from user's card than max card on the floor
			maxCardsArr = getMaxCardsThan(curMaxCard, _cardsArr);
//			cc.log("getHintCards 1");
		}else{
			if(hasTrump(cardsOnFloor)){
				maxCardsArr = getCardsBySuit(curCardMove.suit, _cardsArr);
//				cc.log("getHintCards 2");
			}else{				
				// getting greater cards list from user's card than max card on the floor
				maxCardsArr = getMaxCardsThan(curMaxCard, _cardsArr);
//				cc.log("getHintCards 3");
			}
		}

//		cc.log("========================maxCardsArr.length: "+ maxCardsArr.length + " curMaxCard: "+curMaxCard.suit +" " + curMaxCard.value);
		// if greater cards are available those will be shown as hints
		if(maxCardsArr.length>0){
			hintCardsArr = maxCardsArr;
		}else{
			// else other available cards of led suit will be shown as hints
			cardsBySuitArr = getCardsBySuit(curCardMove.suit, _cardsArr);
			
//			cc.log("========================cardsBySuitArr.length: "+ cardsBySuitArr.length );
			
			if(cardsBySuitArr.length>0){
				hintCardsArr = cardsBySuitArr;
//				cc.log("getHintCards 4");
			}else{
				var maxTrump; 
				if(hasTrump(cardsOnFloor)){
					maxTrump = getMaxCardBySuit(Suits.Trump, cardsOnFloor);
					hintCardsArr = getMaxCardsThan(maxTrump, _cardsArr);
//					cc.log("getHintCards 5");
//					cc.log("3 showHints>curMaxCard: "+ curMaxCard);
//					if(hintCardsArr.length == 0){
//						hintCardsArr = getCardsBySuit(Suits.Trump, _cardsArr);
//					}
				}else{
					hintCardsArr = getCardsBySuit(Suits.Trump, _cardsArr);
//					cc.log("getHintCards 6");
				}
				//				cc.log("====================================maxTrump "+maxSpade.suit + " : "+ maxTrump.value );
				// if user doesn't have any card of led suit then card of spades will be shown as hint
			}
		}	
//		cc.log("========================hintCardsArr.length: "+ hintCardsArr.length );

//		if(cardsOnFloor.length == 3){
//			if(hintCardsArr.length>1){
//				var __maxCard = getMaxCardsThan(curMaxCard, hintCardsArr, true);
//				
//				if(__maxCard != undefined){
//					hintCardsArr = [__maxCard];
//				}
//			}	
//		}
		//---------------------------------------------------------------------------------------------	
		// filtering and creating a different array which consist of other cards than the hint cards

		var otherCardsArr = _cardsArr.filter( function( el ) {
										return hintCardsArr.indexOf( el ) < 0;
									} );
		
		
//		var otherCardsArr = subtractArr(_cardsArr, hintCardsArr);
		
//		cc.log("========================otherCardsArr.length: "+ otherCardsArr.length );
		
		
		var i, len = otherCardsArr.length;
		if(hintCardsArr.length>0 && len>0){
			for(i=0; i<len; i++) {
				if(showHint){
					otherCardsArr[i].runAction(new cc.TintTo(tweenSpeed/2, 100, 100, 100).easing(easing));
					cc.eventManager.pauseTarget(otherCardsArr[i]);
				}else{
					otherCardsArr[i].runAction(new cc.TintTo(tweenSpeed/2, 255, 255, 255).easing(easing));
					cc.eventManager.resumeTarget(otherCardsArr[i]);
				}
			}
		}
		cc.log("showHints: " + showHint +" hintCardsArr.length: " + hintCardsArr.length);
	},
	enableTouch:function (bool){
		if(bool == undefined){
			bool = true;
		}
//		cc.log("enableTouch " + bool);
		
		if(playersArr[0]!=undefined)
		{
			var _cardsArr = playersArr[0].cards;
			var i, max = _cardsArr.length;
			for(i=0; i<max; i++) {
				if(bool){
					cc.eventManager.resumeTarget(_cardsArr[i]);
				}else{
					cc.eventManager.pauseTarget(_cardsArr[i]);
				}
			}
		}
	}
});