/**
 * Created by Jeevan on 10/14/14.
 */

var winSize, visibleSize, origin;
var animateCardsDeal = true;
var tapToThrow = true;
var roundNum = 5;
var playSfx = true;
var showOpponentsCard = true;
var tapToClearFloor = true;
var mustHaveTrump = true;
var mustHaveFaceCard = true;
var isResume = false;
var justStarted = true;
var opponentCardViewMode=1;
var showHint = true;
var showHintTimeout = 0;
var showHintTimeoutId;
var winnerCard;
var curBgImgIndx = 0;
var curCardBackImgIndx = 0;
var btnYpos;
var cardsStartPosArr;

var isDebugMode = false;
var showCardThrowBtn = false; // for testing purpose
var is8BidWinTestMode = false; // for testing purpose

var __gamePlaySpeed = 0.5;
var gamePlaySpeed = 1-__gamePlaySpeed;
var tweenSpeed = 1*gamePlaySpeed;
var dealAnimSpeed = 0.5;
var timeoutTime = 1000*gamePlaySpeed;
var showCardsTill = (tweenSpeed*1000) + timeoutTime*2;

var isPlaying = false;
var gameIsFinished;
var isNopeCard = false;
var trumpCard;

var speedVals = {slow:0.4, normal:0.65, high:0.9};

var cardsScaleVals; 
if(isDebugMode){
	cardsScaleVals = {normal:0.75, scaledDown:0.45, scaledUp:1};
}else{
	cardsScaleVals = {normal:0.9, scaledDown:0.45, scaledUp:1.15};
}


//var easing = cc.easeOut(1.5);
//var easing = cc.easeSineIn();
var easing = cc.easeSineOut();

var isTablet = false;
var turnCount = 0;
var dealTurnCount = 0;
var throwCount = 0;
var callTurnCount = 0;
var callMakingCount = 0;
var roundCount = 1;
var cardSize = 0;
var isBackPressed = false; 

var cardsOnFloor = [];
var thrownCardsArr = [];
var curCardMove; // 1st user's card
var curCardOnFloor;
var isWaiting = false;
var selectedCard;
var curCardTouchPos;
var hintCardsArr = [];
var totalScoresArr = [];
var cardsThrowPosArr = [];

var cardSize;
var resizedCardSize;
var gapV = 30;
var gapH = 30;
var marginV = 5;
var marginH = 5;


var playersArr = [];
//var playersNameArr = ["Jeevanfsd", "Sagunfsdf","Ankitfsdf","Arooonfsdf"];
var playersNameArr = ["You", "P2","P3","P4"];
var scoresArr = [];

var Suits = {
	Diamonds:0,
    Clubs:1,
    Hearts:2,
    Spades:3,
    Trump:3
};

var cardsLayer;
var callPadLayer;
var statusLayer;
var scoresLayer;
var winnerLayer;
var mainMenuLayer;
var bgLayer;

var gameScene;
var mainMenuScene;

// settings key string for local storage
var Settings = {
		
//case 0:
//	playSfx = e.getSelectedIndex() ==1?true:false;
//case 1:
//	showHint = e.getSelectedIndex() ==1?true:false;
//case 2:
//	mustHaveTrump = e.getSelectedIndex() ==1?true:false;
//case 3:
//	mustHaveFaceCard = e.getSelectedIndex() ==1?true:false;
//case 4:
//	animateCardsDeal = e.getSelectedIndex() ==1?true:false;
//case 5:				
//		__gamePlaySpeed == 0.35;
		
		soundEffect:"soundEffect",
		showHint:"showHint",
		mustHaveTrump:"mustHaveTrump",
		mustHaveFaceCard:"mustHaveFaceCard",
		animateCardDeal:"animateCardDeal",
		trumpCard:"trumpCard",
		tapToClearFloor:"tapToClearFloor",
		gamePlaySpeed:"gamePlaySpeed",
		tapToThrow:"tapToThrow",
		roundNum:"roundNum",
		cardBackImg:"cardBackImg",
		customized:"customized",
		bgImg:"bgImg",
		scores:"scores",
		roundCount:"roundCount",
		playerNames:"playerNames"
};

var soundOnBtn;
var soundOffBtn;
var backBtn, scoreBtn, hintToggleBtn, tableBtn;
var speedBtn1, speedBtn2, speedBtn3;

var normalFont = "res/fonts/Roboto-Regular.ttf";
var boldFont = "res/fonts/Roboto-Black.ttf";
var normalFontSize = 26;
var titleFontSize = 34;
//Handle for quick access to Cocos2D's implementation of Local Storage:
var ls;
var scoreDataStr = "";
var gameStateDataStr = "";
var tableBgImgArr = [];
tableBgImgArr.push({thumb: res.tableBgRadialGreenTh , img:res.tableBgRadialGreen});
tableBgImgArr.push({thumb: res.tableBgRadialDarkTh , img:res.tableBgRadialDark});
tableBgImgArr.push({thumb: res.tableBgRadialBlueTh , img:res.tableBgRadialBlue});
tableBgImgArr.push({thumb: res.tableBgRadialRedTh , img:res.tableBgRadialRed});
tableBgImgArr.push({thumb: res.tableBgRadialYellowTh , img:res.tableBgRadialYellow});
tableBgImgArr.push({thumb: res.tableBgRadialBlue2Th , img:res.tableBgRadialBlue2});

var cardBackImgArr = [];
cardBackImgArr.push({thumb: res.blue_card_th , imgId:0});
cardBackImgArr.push({thumb: res.red_card_th , imgId:1});