/**
 * Created by jeevan on 10/23/14.
 */
var WinnerLayer = cc.Layer.extend({
	label:null,
	winsImg:null,
	winImag:null,
	ctor:function () {
		this._super();
		
		var bgImg = new cc.Sprite(res.winnerBg);
		bgImg.setPosition(winSize.width/2, winSize.height/2);
		this.addChild(bgImg);
		scaleTofillScreen(bgImg);
		
		this.label = new cc.LabelTTF("You ", boldFont, 36);
		this.label.setPosition(winSize.width/2, winSize.height*0.41);
		this.label.setColor(cc.color(255,0,0));
		this.addChild(this.label);
		
		this.winImg = new cc.Sprite(res.win);
		this.winImg.setPosition(winSize.width/2, this.label.getPositionY()-110);
		this.addChild(this.winImg);
		this.winImg.visible = false;

		this.winsImg = new cc.Sprite(res.wins);
		this.winsImg.setPosition(winSize.width/2, this.label.getPositionY()-110);
		this.addChild(this.winsImg);
		this.winsImg.visible = false;
		
		var menu = new cc.Menu();
		var seeScoresBtn = new cc.MenuItemImage(res.continueBtn_normal ,res.continueBtn_touch, this.seeScores, this);
		seeScoresBtn.setPositionY(40);
		menu.setPosition(cc.p(winSize.width/2,0));  
		menu.addChild(seeScoresBtn);
		this.addChild(menu);
	},
	showWinner:function(winnerName){
		if(winnerName == "You"){
			this.winImg.visible = true;
			this.winsImg.visible = false;
		}else{
			this.winsImg.visible = true;
			this.winImg.visible = false;
		}
		
		gameIsFinished = true;
		
		this.label.setString("~ "+winnerName+" ~");
		this.label.setPosition(winSize.width/2, winSize.height*0.4);
	},
	seeScores:function(){
		scoresLayer.visible = true;
		winnerLayer.visible = false;
	}
});

