/**
 * Created by user on 31/10/14.
 */
var AboutLayer = cc.Layer.extend({	
	startX:null,
	startY:null,
	textLabel:null,
	aboutGameStr:null,
	creditStr:null,
	ctor:function () {
		this._super();  
		this.init();
		return true;
	},
	init:function(){
		//-----------------------------------------------------                
//		var bgImg = new cc.Sprite(res.callPadBg_img);
//		bgImg.attr({
//			x:  winSize.width/2,
//			y:  winSize.height/2 
//		});  
//		this.addChild(bgImg);
		var titleLabel = new cc.LabelTTF("ABOUT", normalFont, 32);
		titleLabel.setPosition(cc.p(winSize.width/2, winSize.height-90));
		this.addChild(titleLabel);
		
		var label = new cc.LabelTTF("Developed By: Jeevan Shrestha", normalFont, 32);
		label.setPosition(cc.p(winSize.width/2, 25));
		this.addChild(label);
		
		this.aboutGameStr = "";
		this.aboutGameStr += "Call Break is a trick-based card game similar to Spades played in the west. It's widely popular in Nepal and some parts of India. It is known as Lakdi, Lakadi or Lakadia in India. ";
		this.aboutGameStr += "The vintage game of cards features 4 players with 13 cards each to offer virtual gaming experience. ";
		this.aboutGameStr += "There will be five deals/round in a game. Starting a game with a bid/call, a player can compete against 3 computer players with effective artificial intelligence. Initiating a game by throwing a single card of any suit (club, diamond, heart, spade), the other players also follow the same suit unless they runs out of that particular suit. ";
		this.aboutGameStr += "Absence of identical suit allows player to throw a card of another suit and the current round is won by highest card. Spade cards can be used to conquer other cards when no more cards of the same suit are there to offer.e.g. 2 of spade can conquer any higher cards of other suits. ";
		this.aboutGameStr += "If all the players run out of both identical led suit and Spades card then the led card wins regardless of any suit. ";
		this.aboutGameStr += "Play and have a joyful digital experience of one of the legendary game of cards on your phone or tablet."
		
//		  
		this.creditStr = "Credits....";
		
		this.textLabel = new cc.LabelTTF(this.aboutGameStr, normalFont, 26, cc.size(winSize.width-20,winSize.height*2));
		this.textLabel.setPosition(winSize.width/2, 0);
//		this.addChild(this.textLabel);

		 var scrollView = new ccui.ScrollView();
		 scrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
		 scrollView.setTouchEnabled(true);
		 scrollView.setBounceEnabled(true);
		 scrollView.setContentSize(winSize.width, winSize.height-180);
		 scrollView.setInnerContainerSize(cc.size(winSize.width, winSize.height));
		 scrollView.addChild(this.textLabel);
		 scrollView.setPosition(0, winSize.height-scrollView.getContentSize().height-(winSize.height-btnYpos)-40);
		 this.addChild(scrollView);
		
		var i=0, max=3, button, menu, str, gapV = 100;
		
		var buttonNameArr =  ["Back", "About Game", "Credits", "Feedback"];
//		var buttonImgArr = [{n:res.backBtn_n, t:res.backBtn_t},{n:res.aboutGameBtn_normal, t:res.aboutGameBtn_touch}, {n:res.creditBtn_normal, t:res.creditBtn_touch},{n:res.feedbackBtn_normal, t:res.feedbackBtn_touch}];
		var buttonImgArr = [{n:res.backBtn_n, t:res.backBtn_t}];
		this.startX = 240;
		this.startY = btnYpos;

		menu = new cc.Menu();
		menu.setPosition(0,0);

		for(i=0; i<1; i++)
		{
			button = new cc.MenuItemImage(buttonImgArr[i].n,buttonImgArr[i].t, this.onButtonClick, this);
			button.setName(buttonNameArr[i]);
			if(i==0){
				button.setPosition(cc.p(45, this.startY));    
			}else{
				button.setPosition(cc.p(this.startX+(i-1)*320, this.startY));    
			}
					
			menu.addChild(button);
		}

		this.addChild(menu);
		
		//-------
		
		var justBacked = false;
		//add a keyboard event listener to statusLabel
		var keyboardListener = cc.EventListener.create({
			event: cc.EventListener.KEYBOARD,
			onKeyPressed:  function(keyCode, event){
				cc.log("key pressed: "+keyCode);
//				cardsLayer.logLabel.setString("key pressed: "+keyCode + " ");
				if(keyCode == cc.KEY.backspace || keyCode == 6 && !justBacked){
					//do something
					justBacked = true;
					cc.director.runScene(new MainMenuScene());
					justBacked = false;
				}
			},onKeyReleased:  function(keyCode, event){
				cc.log("key onKeyReleased: "+keyCode);
//				cardsLayer.logLabel.setString("key pressed: "+keyCode + " ");
				if(keyCode == cc.KEY.backspace || keyCode == 6 && !justBacked){
					//do something
					justBacked = true;
					cc.director.runScene(new MainMenuScene());
					justBacked = false;
				}
			}
		});

		cc.eventManager.addListener(keyboardListener, this);
	},
	onButtonClick:function(e){
		cc.log("onButtonClick "+ e.getName() );
		switch(e.getName()){
			case "Back":
				//
				cc.director.runScene(new MainMenuScene());
				break
			case "About Game":
				//
				this.textLabel.setString(this.aboutGameStr);
				break	
			case "Credits":
				//
				this.textLabel.setString(this.creditStr);
				break
			case "Feedback":
				//
				break
		}
	}
});