/**
 * Created by user on 10/8/14.
 */
var MainMenuScene = cc.Scene.extend({
    onEnter:function () {
        this._super();        
        //---------
        mainMenuLayer = new MainMenuLayer();
        this.addChild(mainMenuLayer,3);   

        bgLayer = new BackgroundLayer(tableBgImgArr[curBgImgIndx].img);
        this.addChild(bgLayer);
    }
});

//---------------------------------------------------------------------------------

var GameScene = cc.Scene.extend({
	onEnter:function () {
		this._super();
		//---------
                                
                                        
		bgLayer = new BackgroundLayer(tableBgImgArr[curBgImgIndx].img);
		this.addChild(bgLayer);

		statusLayer = new StatusLayer();
		this.addChild(statusLayer);  

		callPadLayer = new CallPadLayer();       
		callPadLayer.visible = false;
		this.addChild(callPadLayer);

		cardsLayer = new CardsLayer();        
		this.addChild(cardsLayer);

		scoresLayer = new ScoresLayer();
		scoresLayer.visible = false;
		this.addChild(scoresLayer);

		winnerLayer = new WinnerLayer();
		winnerLayer.visible = false;
		this.addChild(winnerLayer);
	}
});

GameScene.showCallPad = function(bool){
	if(bool == undefined){
		bool = true;
	}
	cc.log("showCallPad "+bool);
	if(statusLayer!=undefined)
	{
		statusLayer.visible = bool;
		callPadLayer.visible = bool;  
	}
}

GameScene.onCallMade = function(val){
	cc.log("onCallMade "+val);
	callPadLayer.visible = false;
	cardsLayer.makeCall(val);
}
//--------

var SettingsScene = cc.Scene.extend({
	onEnter:function () {
		this._super();        
		//---------

		bgLayer = new BackgroundLayer(tableBgImgArr[curBgImgIndx].img);
		this.addChild(bgLayer);

		cc.log("SettingsScene>bgLayer ", bgLayer);
		
		var settingsLayer = new SettingsLayer();
		this.addChild(settingsLayer);    
	}
});

SettingsScene.updateBg = function(val){
	cc.log("onCallMade "+val);
	callPadLayer.visible = false;
	cardsLayer.makeCall(val);
}

var AboutScene = cc.Scene.extend({
	onEnter:function () {
		this._super();        
		//---------
		bgLayer = new BackgroundLayer(tableBgImgArr[curBgImgIndx].img);
		this.addChild(bgLayer);

		var layer = new AboutLayer();
		this.addChild(layer);    
	}
});
