/**
 * Created by user on 10/14/14.
 */

var ScoresLayer = cc.Layer.extend({
    cardsStartPosArr:null,
    startX:null,
    startY:null,
    node:null,
    clipper:null,
    totalLabelsArr:null,
    okBtn:null,
    gapV:null,
    gapH:null,
    opacVals:null,
    fontSizeVals:null,
    boxArr:null,
    scrollView:null,
    ctor:function () {
        this._super();
        this.scheduleOnce(this.init, 0.75);
        //-------------------------------------------
        return true;
    },
    init:function(){
//    	var rect = new cc.rect(0, 0, 102, 102); 
//    	var capInsets = new cc.rect(25, 25, 52, 52); 
//    	var bgImg = new cc.Scale9Sprite(res.bgRect, rect, capInsets);
    	this.boxArr = [];
    	bgImg = new cc.Sprite(res.scoreBg2);
    	bgImg.setScaleX(winSize.width / bgImg.getContentSize().width);
    	bgImg.setScaleY(winSize.height / bgImg.getContentSize().height);
    	
//    	var bgImg = new cc.Sprite(res.scoreBg);
	  	bgImg.attr({
		  	x:  visibleSize.width/2,
		  	y:  visibleSize.height/2
	  	});  
	  	
//	  	bgImg.setContentSize(780, 510);
	  	bgImg.setName("bg");
	  	this.addChild(bgImg);

    	this.opacVals = {heading:220, total:255,i0:120,i1:60}; 
    	this.fontSizeVals = {heading:30, total:30,item:26};
    	this.totalLabelsArr = [];

    	this.gapV = 52;
    	this.gapH = 152;

    	var i=0, max=5, col = 4, label, bgRect;

    	this.startX = visibleSize.width - (max*this.gapH)-55;
    	this.startY = this.gapV*3.25;
    	
    	this.node = new cc.Node();
    	this.node.setPosition(cc.p(this.startX, visibleSize.height/2-this.startY));
//    	this.addChild(this.node);    	
//    	this.node = new cc.ClippingNode()
    	
//    	this.clipper = new cc.ClippingNode();
//
//    	this.node.setPosition(cc.p(this.startX, visibleSize.height/2+this.startY));
//    	
//    	var clipRect = {x:0,y:0,width:800,height:500};
//    	
//    	var stencil = new cc.DrawNode();
//    	var rectangle = [cc.p(clipRect.x, clipRect.y),cc.p(clipRect.width, 0),
//    	                 cc.p(clipRect.width, clipRect.height),
//    	                 cc.p(clipRect.x, clipRect.height)];
//    	var white = cc.color(255, 255, 255, 255);
//    	stencil.drawRect(cc.p(-75,-336), cc.p(900,600), white);
//
//    	this.clipper.setStencil(stencil);
//    	
//    	this.clipper.addChild(this.node);
//    	
//    	this.addChild(this.clipper);
    	
    	var titlePosY = visibleSize.height-100;
    	var title = new cc.LabelTTF("Score Table", normalFont, 36);
    	title.setAnchorPoint(0.5,0.6);
    	title.setPosition(cc.p(visibleSize.width/2, titlePosY));
    	
    	this.addChild(title);

    	var str = "";
    	
    	var headingPosY = visibleSize.height- ((visibleSize.height - (320-50))/2);
    	var totalPosY = headingPosY-320;
    	// creating heading and total text boxes
    	for(i=0; i<5; i++)
    	{
    		if(i == 0){
    			str = "Round";
    		}else{
    			str = playersArr[i-1].name;
    		}

    		bgRect = new cc.Sprite(res.rectImg);
    		bgRect.setPosition(cc.p(210+i*this.gapH,headingPosY));
    		bgRect.setOpacity(this.opacVals.heading);
    		this.addChild(bgRect);  

    		label = new cc.LabelTTF(str, boldFont, this.fontSizeVals.heading);
    		label.setPosition(bgRect.getPosition()); 		
    		this.addChild(label);  
    		
    		// creating total text box, labels
    		if(i == 0){
    			str = "Total";
    		}else{
    			str = "-00.0";
    		}

    		bgRect = new cc.Sprite(res.rectImg);
    		bgRect.setOpacity(this.opacVals.total);
    		bgRect.setPosition(cc.p(210+i*this.gapH,totalPosY));  
    		
    		label = new cc.LabelTTF(str, boldFont, this.fontSizeVals.total);
    		label.setPosition(bgRect.getPosition());  
    		
    		this.totalLabelsArr.push({label:label, bgRect:bgRect});
    		
    		this.addChild(bgRect);
    		this.addChild(label);
    	}
    	
    	//-------------------------------------------
    	
    	// creating the table with text boxes ----
//    	roundCount = 0;
    	for(i=1;i<=roundNum;i++){
    		var k=0, l=0, max=5, col = 4, bgRect;
    		var label, str = "";
    		var tmpBoxArr = [];
    		for(k=0; k<max; k++)
    		{   
    			bgRect = new cc.Sprite(res.rectImg);
    			bgRect.setPosition(cc.p(k*this.gapH,-this.gapV*i));
    			this.node.addChild(bgRect);  

    			if((i-1)%2 == 0 ){
    				bgRect.setOpacity(this.opacVals.i0);
    			}else{
    				bgRect.setOpacity(this.opacVals.i1);
    			}

    			if(k == 0){
    				str = i;
    			}else{
    				str = "-";
    			}
    			
    			label = new cc.LabelTTF(str, normalFont, this.fontSizeVals.item);
    			label.setPosition(bgRect.getPosition()); 
    			tmpBoxArr.push({bg:bgRect, label:label});
    			this.node.addChild(label); 
    		} 
    		this.boxArr.push(tmpBoxArr);
    	}

    	var menu = new cc.Menu();
    	var okBtn = new cc.MenuItemImage(res.x_btn ,res.x_btn_s, this.onMenuItemClick, this);
    	okBtn.setName("ok");
    	okBtn.setPosition(visibleSize.width/2-70, visibleSize.height/2-150);
    	menu.addChild(okBtn);

    	this.addChild(menu);    	

    	//---------------------------------------------
    	this.scrollView = new ccui.ScrollView();
    	this.scrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
    	this.scrollView.setTouchEnabled(true);
    	this.scrollView.setBounceEnabled(true);
    	this.scrollView.setContentSize(151*6, 262);

    	this.node.setPositionY((roundNum+0.5)*this.gapV);

    	this.scrollView.setInnerContainerSize(cc.size(150*5, (roundNum)*this.gapV));

    	this.scrollView.addChild(this.node);
    	this.scrollView.setPosition(0, headingPosY-265-27);
    	this.addChild(this.scrollView);
    	
    	// updating scores according to the scoreArr
    	max = scoresArr.length;
    	cc.log("scoresLayer>scoresArr.length "+ scoresArr.length);
    	for(i=0; i<max; i++)
    	{
    		this.updateScores(i, false);
    	}
    	
    	//---------------- for scroll testing ------------------
//    	var from = 6, to = 20;
//    	for(i=from;i<=to;i++){
//    		var btn = new cc.MenuItemFont("  "+String(i)+"  ", this.onMenuItemClick, this);
//    		btn.setName(String(i));
//    		btn.setPosition(visibleSize.width/2 -60 - 65*(i-from), visibleSize.height/2-60);
//    		menu.addChild(btn);
//    	}
    },
    updateScores:function(rowNum, isNewEntry){
    	var k=0, l=0,  max=5, col = 4, bgRect;
    	totalScoresArr = [];
    	
    	var score, player, sArr = [], label, totalScore=0, str = "", redCircle;
    	    
    	if(isNewEntry == undefined)
    	{
    		isNewEntry = true;
    		rowNum = roundCount-1;
    	}

    	var log = "updateScores>rowNum: "+ rowNum + "\n";
    	
    	for(k=1; k<max; k++)
    	{   
			player = playersArr[k-1];
    		//-------------------------------------------------
			if(!isNewEntry)
			{
				score = scoresArr[rowNum][k-1];
				str = resolveScore(String(score));
			}else{
				if(player!=undefined)
				{
					if(player.hands<player.bidVal){
						score = - player.bidVal;
					}else {
						score = Number(player.bidVal) + Number((player.hands - player.bidVal)/10);
					}

					if(k<max-1){
						scoreDataStr += score + ":"
					}else{
						scoreDataStr += score + "|"
					}

					sArr.push(score);
				}
				str = resolveScore(String(score));
			}

			log += " call: " + player.bidVal + " hand: "+player.hands + " score: "+score + "\n";
			
    		label = this.boxArr[rowNum][k].label;
    		label.setString(str);

    		if(score<0){
    			redCircle = new cc.Sprite(res.redCircle);
    			redCircle.setScale(0.75);
    			redCircle.setPosition(label.getPosition());
    			this.node.addChild(redCircle);  
			}
    	} 

    	if(isNewEntry)
    	{
    		scoresArr.push(sArr);
    	}
    	//-------------- updating total scores ------------------
//    	log = "+round: "+ roundCount + " totalScore: ";
    	
    	if(roundCount>0){
	    	for(k=0; k<5; k++)
	    	{
	    		if(this.totalLabelsArr[k]!=undefined)
	    		{
		    		label = this.totalLabelsArr[k].label;
		    		bgRect = this.totalLabelsArr[k].bgRect;    		
		    		
//		    		label.setPosition(cc.p((k)*this.gapH,-this.gapV*(roundCount+1))); 	    	
//			    	bgRect.setPosition(label.getPosition());
			    	
		    		if(k>0){
		    			totalScore = 0;
		    			for(l=0; l<scoresArr.length; l++)
		    			{
		    				totalScore += Number(scoresArr[l][k-1]);
		    			}
//		    			log += "  " +totalScore;
		    			label.setString(String(resolveScore(totalScore)));	
	
		    			totalScoresArr.push(Number(totalScore));
	
		    			if(totalScore<0){
		    				redCircle = new cc.Sprite(res.redCircle);
		    				redCircle.setScale(0.75);
		    				redCircle.setPosition(label.getPosition());
		    				this.node.addChild(redCircle);  
		    			}
		    		}
		    		//---
			    	
			    	label.visible = true;
			    	bgRect.visible = true;
	    		}	
	    	}
//	    	cc.log(log);
    	}

    	cc.log("this.scrollView.getInnerContainer().getPositionY() "+this.scrollView.getInnerContainer().getPositionY());
    	cc.log("this.scrollView.getInnerContainerSize "+this.scrollView.getInnerContainerSize().height);
    	
          var containerHeight = 52*roundNum;
          var containerPosY = containerHeight-(52*5)-2;
    	if(this.scrollView.getInnerContainer().getPositionY()>-containerPosY || roundCount>5)
    	{
            var pct = Math.ceil(((roundCount-4)/roundNum)*100);
//            cc.log("pct "+ pct);
    		this.scrollView.scrollToPercentVertical(pct,0.2, true);
    	}
    },
    onMenuItemClick:function(e){
//    	cc.log("scoresLayer>onMenuItemClick>throwCount: "+ throwCount);
//    	var sv = this.scrollView;
    	if(e.getName() == "ok")
    	{
	    		if(isPlaying){
	    			this.visible = false;
	    		}else{
	    			
	    			cardsLayer.playNextRound();
	    		}
	    		//------------------------------------------------------------------
//	    		var pct = Math.ceil((roundCount-6)/roundNum)*100;
//	    		cc.log("--------------- "+ sv.getInnerContainer().getPosition().y);
//	    		this.scrollView.scrollToPercentVertical(pct,0.05, true);
//    		cc.log("posYPct: " + sv.getInnerContainer().getPositionPercent().y);
//    		this.scrollView.scrollToPercentVertical((6/50)*100,0.1, true);
    	}else{
//    		cc.log("e.getName() ", e.getName());
//    		var rcount = Number(e.getName())-4;
//    		var pct = Math.ceil((rcount/roundNum)*100);
//    		cc.log("scroll pct "+ pct + " roundNum "+roundNum);
//    		this.scrollView.scrollToPercentVertical(pct,0.1, true);
    	}
    }
});

